module incr(o,i);
   output reg [3:0] o;
   input [3:0] 	    i;

   always @(i)
     o=i+1;
endmodule // incr

module cntr(C, pulse, Z);
   input C, pulse;
   output reg [3:0] Z;

   wire [3:0] 	    Zin;

   incr myincr(Zin,Z);

   always @(posedge pulse)
     if (C)
       Z <= Zin;

   always @(posedge C)
     Z <= 4'b0000;
endmodule // cntr

module testbed;
   reg pulse;
   reg C;
   wire [3:0] Zout;

   cntr mycntr(C, pulse, Zout);

   initial
     begin
	C     = 1'b0;
	pulse = 1'b0;
	#1;
	C     = 1'b1;
	#1;
	repeat (20) 
	  begin
	     pulse = 1'b1;
	     #1;
	     pulse = 1'b0;
	     #1;
	     $display("Zout: %d\n",Zout);
	  end
	$finish;
     end // initial begin
endmodule // testbed
